// mainfrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "keywin.h"

#include "mainfrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

extern char *Response;
extern char *Challenge;
extern HANDLE CreateCFTEXTObject(char *data, int length);

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{

    // Call the base class function.
    CFrameWnd::PreCreateWindow( cs );

    // Set the width of the window to 122.
    cs.cx = 370;

    // Set the height of the window to 90.
    cs.cy = 190;

    // Make the window a topmost window.
//    cs.dwExStyle = WS_EX_TOPMOST;

    return TRUE;
}                            

void CMainFrame::OnEditCopy()
{
	HANDLE datahandle;
	
	UpdateData(TRUE);
	if(!OpenClipboard()) {
		AfxMessageBox("Cannot open the clipboard");
		return;
	}
	if(!EmptyClipboard()) {
		AfxMessageBox("Cannot empty the clipboard");
		return;
	}
	
	strcat(Response,"\n");
	datahandle = CreateCFTEXTObject(Response,strlen(Response));
	
	if(!SetClipboardData(CF_TEXT,datahandle)) {
		AfxMessageBox("Cannot change clipboard");
	}
	CloseClipboard();
}

void CMainFrame::OnEditPaste()
{
	HANDLE hClipMemory;
	HGLOBAL hMyMemory;        
	LPSTR pClipMemory;
	LPSTR pMyMemory;
	
	if(IsClipboardFormatAvailable(CF_TEXT)) {    
		if(!OpenClipboard()) {
			AfxMessageBox("unable to open clipboard");
			return;
		}
		hClipMemory = GetClipboardData(CF_TEXT);
		if (hClipMemory == NULL) {
			AfxMessageBox("Unable to get clipboard data");
			return;
		}
    	hMyMemory = GlobalAlloc(GHND,GlobalSize(hClipMemory));
		if (hMyMemory == NULL) {
			MessageBox("Out of Memory");
			CloseClipboard();
			return;
		}
		pClipMemory = (LPSTR)GlobalLock(hClipMemory); 
		pMyMemory = (LPSTR)GlobalLock(hMyMemory);
		lstrcpy(pMyMemory,pClipMemory);
		lstrcpy(Challenge,pMyMemory);
		UpdateData(FALSE);
		GlobalUnlock(hClipMemory);
		GlobalUnlock(hMyMemory);
		CloseClipboard();
	}
}
